from AutoRPE.UtilsRPE.Functions import load_vault
from UtilsRPE.Classes import Interface, Routine, Function
# Getting Command line options
from optparse import OptionParser
parser = OptionParser()
parser.add_option("-v", "--vault", dest="vault", default="./vault.pkl", metavar="FILE")
parser.add_option("-n","--name",  dest="var_name", default=None)
parser.add_option("--name-contains",  dest="var_name_contains", default=None)
parser.add_option("-r","--routine",  dest="routine_name", default=None)
parser.add_option("-i","--interface",  dest="interface_name", default=None)
parser.add_option("-m","--module",  dest="module_name", default=None)
(options, args) = parser.parse_args()

vault_path = options.vault
var_name = options.var_name
var_name_contains = options.var_name_contains
routine_name = options.routine_name
interface_name = options.interface_name
module_name = options.module_name

# Loading vault (source database)
print("Loading Vault from: %s" % vault_path)
vault = load_vault(vault_path)

procedures = vault.procedures

prec = {23: "single",52: "double"}

if interface_name is not None:
   interfaces = [ p for p in procedures if isinstance(p, Interface)]
   try:
      my_interface = [ i for i in interfaces if i.name == interface_name][0]
   except IndexError:
      print("Inferface not found!")
      exit(0)
   for p in my_interface.procedures:
      print(p.name)
      for v in p.variables:
         if v.is_dummy_argument:
            if v.type == "real":
               print("\t",v.name, prec[v.precision].upper(), "\tID:", v.id)
            else:
               print("\t",v.name, v.type)
               
   
